/* Generated by re2c 0.9.1-C on Sun Feb 25 05:44:07 2007
 */
#line 1 "./modules/parsers/gas/gas-token.re"
/*
 * GAS-compatible re2c lexer
 *
 *  Copyright (C) 2005  Peter Johnson
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of other contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND OTHER CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR OTHER CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */
#include <util.h>
RCSID("$Id: gas-token.re 1724 2006-12-30 03:19:24Z peter $");

#define YASM_LIB_INTERNAL
#include <libyasm.h>

#include "modules/parsers/gas/gas-parser.h"


#define BSIZE	8192

#define YYCURSOR	cursor
#define YYLIMIT		(s->lim)
#define YYMARKER	(s->ptr)
#define YYFILL(n)	{cursor = fill(parser_gas, cursor);}

#define RETURN(i)	{s->cur = cursor; parser_gas->tokch = s->tok[0]; \
			 return i;}

#define SCANINIT()	{s->tok = cursor;}

#define TOK		((char *)s->tok)
#define TOKLEN		(size_t)(cursor-s->tok)

static size_t
rept_input(yasm_parser_gas *parser_gas, /*@out@*/ YYCTYPE *buf,
	   size_t max_size)
{
    gas_rept *rept = parser_gas->rept;
    size_t numleft = max_size;
    YYCTYPE *bufp = buf;

    /* If numrept is 0, copy out just the line end characters */
    if (rept->numrept == 0) {
	/* Skip first line, which contains .line */
	rept->line = STAILQ_NEXT(rept->line, link);
	if (!rept->line) {
	    rept->numrept = 1;
	    rept->numdone = 1;
	}
	while (rept->numrept == 0 && numleft > 0) {
	    *bufp++ = rept->line->data[rept->line->len-1];
	    rept->line = STAILQ_NEXT(rept->line, link);
	    if (!rept->line) {
		rept->numrept = 1;
		rept->numdone = 1;
	    }
	}
    }

    /* Copy out the previous fill buffer until we're *really* done */
    if (rept->numdone == rept->numrept) {
	size_t numcopy = rept->oldbuflen - rept->oldbufpos;
	if (numcopy > numleft)
	    numcopy = numleft;
	memcpy(bufp, &rept->oldbuf[rept->oldbufpos], numcopy);
	numleft -= numcopy;
	bufp += numcopy;
	rept->oldbufpos += numcopy;

	if (rept->oldbufpos == rept->oldbuflen) {
	    /* Delete lines, then delete rept and clear rept state */
	    gas_rept_line *cur, *next;
	    cur = STAILQ_FIRST(&rept->lines);
	    while (cur) {
		next = STAILQ_NEXT(cur, link);
		yasm_xfree(cur->data);
		yasm_xfree(cur);
		cur = next;
	    }
	    yasm_xfree(rept->oldbuf);
	    yasm_xfree(rept);
	    parser_gas->rept = NULL;
	}
    }

    while (numleft > 0 && rept->numdone < rept->numrept) {
	/* Copy from line data to buf */
	size_t numcopy = rept->line->len - rept->linepos;
	if (numcopy > numleft)
	    numcopy = numleft;
	memcpy(bufp, &rept->line->data[rept->linepos], numcopy);
	numleft -= numcopy;
	bufp += numcopy;
	rept->linepos += numcopy;

	/* Update locations if needed */
	if (rept->linepos == rept->line->len) {
	    rept->line = STAILQ_NEXT(rept->line, link);
	    rept->linepos = 0;
	}
	if (rept->line == NULL) {
	    rept->numdone++;
	    rept->line = STAILQ_FIRST(&rept->lines);
	}
    }

    return (max_size-numleft);
}

static size_t
fill_input(void *d, unsigned char *buf, size_t max)
{
    return yasm_preproc_input((yasm_preproc *)d, (char *)buf, max);
}

static YYCTYPE *
fill(yasm_parser_gas *parser_gas, YYCTYPE *cursor)
{
    yasm_scanner *s = &parser_gas->s;
    int first = 0;
    if(!s->eof){
	size_t cnt = s->tok - s->bot;
	if(cnt){
	    memmove(s->bot, s->tok, (size_t)(s->lim - s->tok));
	    s->tok = s->bot;
	    s->ptr -= cnt;
	    cursor -= cnt;
	    s->lim -= cnt;
	}
	if (!s->bot)
	    first = 1;
	if((s->top - s->lim) < BSIZE){
	    YYCTYPE *buf = yasm_xmalloc((size_t)(s->lim - s->bot) + BSIZE);
	    memcpy(buf, s->tok, (size_t)(s->lim - s->tok));
	    s->tok = buf;
	    s->ptr = &buf[s->ptr - s->bot];
	    cursor = &buf[cursor - s->bot];
	    s->lim = &buf[s->lim - s->bot];
	    s->top = &s->lim[BSIZE];
	    if (s->bot)
		yasm_xfree(s->bot);
	    s->bot = buf;
	}
	if (parser_gas->rept && parser_gas->rept->ended) {
	    /* Pull from rept lines instead of preproc */
	    cnt = rept_input(parser_gas, s->lim, BSIZE);
	} else if((cnt = yasm_preproc_input(parser_gas->preproc,
					    (char *)s->lim, BSIZE)) == 0) {
	    s->eof = &s->lim[cnt]; *s->eof++ = '\n';
	}
	s->lim += cnt;
	if (first && parser_gas->save_input) {
	    int i;
	    YYCTYPE *saveline;
	    parser_gas->save_last ^= 1;
	    saveline = parser_gas->save_line[parser_gas->save_last];
	    /* save next line into cur_line */
	    for (i=0; i<79 && &s->tok[i] < s->lim && s->tok[i] != '\n'; i++)
		saveline[i] = s->tok[i];
	    saveline[i] = '\0';
	}
    }
    return cursor;
}

static YYCTYPE *
save_line(yasm_parser_gas *parser_gas, YYCTYPE *cursor)
{
    yasm_scanner *s = &parser_gas->s;
    int i = 0;
    YYCTYPE *saveline;

    parser_gas->save_last ^= 1;
    saveline = parser_gas->save_line[parser_gas->save_last];

    /* save next line into cur_line */
    if ((YYLIMIT - YYCURSOR) < 80)
	YYFILL(80);
    for (i=0; i<79 && &cursor[i] < s->lim && cursor[i] != '\n'; i++)
	saveline[i] = cursor[i];
    saveline[i] = '\0';
    return cursor;
}

/* starting size of string buffer */
#define STRBUF_ALLOC_SIZE	128

/* string buffer used when parsing strings/character constants */
static YYCTYPE *strbuf = NULL;

/* length of strbuf (including terminating NULL character) */
static size_t strbuf_size = 0;

static void
strbuf_append(size_t count, YYCTYPE *cursor, yasm_scanner *s, int ch)
{
    if (cursor == s->eof)
	yasm_error_set(YASM_ERROR_SYNTAX,
		       N_("unexpected end of file in string"));

    if (count >= strbuf_size) {
	strbuf = yasm_xrealloc(strbuf, strbuf_size + STRBUF_ALLOC_SIZE);
	strbuf_size += STRBUF_ALLOC_SIZE;
    }
    strbuf[count] = ch;
}

#line 237 "./modules/parsers/gas/gas-token.re"



int
gas_parser_lex(YYSTYPE *lvalp, yasm_parser_gas *parser_gas)
{
    /*@null@*/ gas_rept *rept = parser_gas->rept;
    yasm_scanner *s = &parser_gas->s;
    YYCTYPE *cursor = s->cur;
    size_t count;
    YYCTYPE savech;
    int linestart;
    gas_rept_line *new_line;

    /* Handle one token of lookahead */
    if (parser_gas->peek_token != NONE) {
	int tok = parser_gas->peek_token;
	*lvalp = parser_gas->peek_tokval;  /* structure copy */
	parser_gas->tokch = parser_gas->peek_tokch;
	parser_gas->peek_token = NONE;
	return tok;
    }

    /* Catch EOF */
    if (s->eof && cursor == s->eof)
	return 0;

    /* Handle rept */
    if (rept && !rept->ended)
	goto rept_directive;

    /* Jump to proper "exclusive" states */
    switch (parser_gas->state) {
	case COMMENT:
	    goto comment;
	case SECTION_DIRECTIVE:
	    goto section_directive;
	default:
	    break;
    }

scan:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   3,   0,   2,   2,   3,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  3,   2,   2,   2,   6,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   6,   2, 
	254, 254, 190, 190, 190, 190, 190, 190, 
	158, 158,   2,   2,   2,   2,   2,   2, 
	  2, 142, 142, 142, 142, 142, 142,  14, 
	 14,  14,  14,  14,  14,  14,  14,  14, 
	 14,  14,  14,  14,  14,  14,  14,  14, 
	 14,  14,  14,   2,   2,   2,   2,   6, 
	  2, 142, 142, 142, 142, 142, 142,  14, 
	 14,  14,  14,  14,  14,  14,  14,  14, 
	 14,  14,  14,  14,  14,  14,  14,  14, 
	 14,  14,  14,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	  2,   2,   2,   2,   2,   2,   2,   2, 
	};

#line 312 "gas-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if(yych <= '0'){
		if(yych <= '"'){
			if(yych <= '\f'){
				if(yych <= '\b')	goto yy31;
				if(yych <= '\t')	goto yy27;
				if(yych <= '\n')	goto yy29;
				goto yy31;
			} else {
				if(yych <= '\037'){
					if(yych <= '\r')	goto yy27;
					goto yy31;
				} else {
					if(yych <= ' ')	goto yy27;
					if(yych <= '!')	goto yy13;
					goto yy7;
				}
			}
		} else {
			if(yych <= '&'){
				if(yych <= '#')	goto yy25;
				if(yych == '%')	goto yy21;
				goto yy13;
			} else {
				if(yych <= '-'){
					if(yych <= '\'')	goto yy5;
					goto yy13;
				} else {
					if(yych <= '.')	goto yy18;
					if(yych <= '/')	goto yy15;
					goto yy2;
				}
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '<'){
				if(yych <= '9')	goto yy4;
				if(yych <= ':')	goto yy13;
				if(yych <= ';')	goto yy16;
				goto yy9;
			} else {
				if(yych <= '>'){
					if(yych <= '=')	goto yy13;
					goto yy11;
				} else {
					if(yych <= '?')	goto yy31;
					if(yych <= '@')	goto yy13;
					goto yy23;
				}
			}
		} else {
			if(yych <= 'z'){
				if(yych <= '^'){
					if(yych <= ']')	goto yy31;
					goto yy13;
				} else {
					if(yych <= '_')	goto yy20;
					if(yych <= '`')	goto yy31;
					goto yy23;
				}
			} else {
				if(yych <= '|'){
					if(yych <= '{')	goto yy31;
					goto yy13;
				} else {
					if(yych == '~')	goto yy13;
					goto yy31;
				}
			}
		}
	}
yy2:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 32) {
		goto yy322;
	}
	if(yych <= 'X'){
		if(yych <= 'F'){
			if(yych == 'B')	goto yy325;
			if(yych >= 'D')	goto yy319;
			goto yy3;
		} else {
			if(yych == 'T')	goto yy319;
			if(yych >= 'X')	goto yy321;
			goto yy3;
		}
	} else {
		if(yych <= 'f'){
			if(yych == 'b')	goto yy325;
			if(yych >= 'd')	goto yy319;
			goto yy3;
		} else {
			if(yych <= 't'){
				if(yych >= 't')	goto yy319;
				goto yy3;
			} else {
				if(yych == 'x')	goto yy321;
				goto yy3;
			}
		}
	}
yy3:
#line 283 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    lvalp->intn = yasm_intnum_create_dec(TOK);
	    s->tok[TOKLEN] = savech;
	    RETURN(INTNUM);
	}
#line 431 "gas-token.c"
yy4:	yych = *++YYCURSOR;
	goto yy318;
yy5:	yych = *++YYCURSOR;
	goto yy6;
yy6:
#line 329 "./modules/parsers/gas/gas-token.re"
{
	    goto charconst;
	}
#line 441 "gas-token.c"
yy7:	yych = *++YYCURSOR;
	goto yy8;
yy8:
#line 334 "./modules/parsers/gas/gas-token.re"
{
	    goto stringconst;
	}
#line 449 "gas-token.c"
yy9:	yych = *++YYCURSOR;
	if(yych == '<')	goto yy315;
	goto yy10;
yy10:
#line 341 "./modules/parsers/gas/gas-token.re"
{ RETURN(LEFT_OP); }
#line 456 "gas-token.c"
yy11:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy313;
	goto yy12;
yy12:
#line 342 "./modules/parsers/gas/gas-token.re"
{ RETURN(RIGHT_OP); }
#line 463 "gas-token.c"
yy13:	yych = *++YYCURSOR;
	goto yy14;
yy14:
#line 343 "./modules/parsers/gas/gas-token.re"
{ RETURN(s->tok[0]); }
#line 469 "gas-token.c"
yy15:	yych = *++YYCURSOR;
	if(yych == '*')	goto yy311;
	goto yy14;
yy16:	yych = *++YYCURSOR;
	goto yy17;
yy17:
#line 344 "./modules/parsers/gas/gas-token.re"
{
	    parser_gas->state = INITIAL;
	    RETURN(s->tok[0]);
	}
#line 481 "gas-token.c"
yy18:	yych = *++YYCURSOR;
	switch(yych){
	case '1':	goto yy48;
	case '2':	goto yy49;
	case '4':	goto yy50;
	case '8':	goto yy51;
	case 'A':	case 'a':	goto yy52;
	case 'B':	case 'b':	goto yy53;
	case 'C':	case 'c':	goto yy54;
	case 'D':	case 'd':	goto yy55;
	case 'E':	case 'e':	goto yy56;
	case 'F':	case 'f':	goto yy57;
	case 'G':	case 'g':	goto yy58;
	case 'H':	case 'h':	goto yy59;
	case 'I':	case 'i':	goto yy60;
	case 'L':	case 'l':	goto yy61;
	case 'O':	case 'o':	goto yy62;
	case 'P':	case 'p':	goto yy63;
	case 'Q':	case 'q':	goto yy64;
	case 'R':	case 'r':	goto yy65;
	case 'S':	case 's':	goto yy66;
	case 'T':	case 't':	goto yy67;
	case 'U':	case 'u':	goto yy68;
	case 'V':	case 'v':	goto yy69;
	case 'W':	case 'w':	goto yy70;
	case 'Z':	case 'z':	goto yy71;
	default:	goto yy47;
	}
yy19:
#line 515 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
	    RETURN(ID);
	}
#line 516 "gas-token.c"
yy20:	yych = *++YYCURSOR;
	goto yy47;
yy21:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 8) {
		goto yy43;
	}
	goto yy22;
yy22:
#line 600 "./modules/parsers/gas/gas-token.re"
{
	    yasm_warn_set(YASM_WARN_UNREC_CHAR,
			  N_("ignoring unrecognized character `%s'"),
			  yasm__conv_unprint(s->tok[0]));
	    goto scan;
	}
#line 532 "gas-token.c"
yy23:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 4) {
		goto yy36;
	}
	if(yych <= '\r'){
		if(yych == '\t')	goto yy38;
		if(yych >= '\r')	goto yy38;
		goto yy24;
	} else {
		if(yych <= ' '){
			if(yych >= ' ')	goto yy38;
			goto yy24;
		} else {
			if(yych == ':')	goto yy41;
			goto yy24;
		}
	}
yy24:
#line 561 "./modules/parsers/gas/gas-token.re"
{
	    /* Can only be an instruction/prefix when not inside an
	     * instruction or directive.
	     */
	    if (parser_gas->state != INSTDIR) {
		savech = s->tok[TOKLEN];
		s->tok[TOKLEN] = '\0';
		switch (yasm_arch_parse_check_insnprefix
			(parser_gas->arch, lvalp->arch_data, TOK, TOKLEN)) {
		    case YASM_ARCH_INSN:
			s->tok[TOKLEN] = savech;
			parser_gas->state = INSTDIR;
			RETURN(INSN);
		    case YASM_ARCH_PREFIX:
			s->tok[TOKLEN] = savech;
			RETURN(PREFIX);
		    default:
			s->tok[TOKLEN] = savech;
		}
	    }
	    /* Propagate errors in case we got a warning from the arch */
	    yasm_errwarn_propagate(parser_gas->errwarns, cur_line);
	    /* Just an identifier, return as such. */
	    lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
	    RETURN(ID);
	}
#line 579 "gas-token.c"
yy25:	yych = *++YYCURSOR;
	goto yy35;
yy26:
#line 589 "./modules/parsers/gas/gas-token.re"
{ goto scan; }
#line 585 "gas-token.c"
yy27:	yych = *++YYCURSOR;
	goto yy33;
yy28:
#line 591 "./modules/parsers/gas/gas-token.re"
{ goto scan; }
#line 591 "gas-token.c"
yy29:	yych = *++YYCURSOR;
	goto yy30;
yy30:
#line 593 "./modules/parsers/gas/gas-token.re"
{
	    if (parser_gas->save_input)
		cursor = save_line(parser_gas, cursor);
	    parser_gas->state = INITIAL;
	    RETURN(s->tok[0]);
	}
#line 602 "gas-token.c"
yy31:	yych = *++YYCURSOR;
	goto yy22;
yy32:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy33;
yy33:	if(yybm[0+yych] & 1) {
		goto yy32;
	}
	goto yy28;
yy34:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy35;
yy35:	if(yybm[0+yych] & 2) {
		goto yy34;
	}
	goto yy26;
yy36:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy37;
yy37:	if(yybm[0+yych] & 4) {
		goto yy36;
	}
	if(yych <= '\r'){
		if(yych == '\t')	goto yy38;
		if(yych <= '\f')	goto yy24;
		goto yy38;
	} else {
		if(yych <= ' '){
			if(yych <= '\037')	goto yy24;
			goto yy38;
		} else {
			if(yych == ':')	goto yy41;
			goto yy24;
		}
	}
yy38:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy39;
yy39:	if(yych <= '\r'){
		if(yych == '\t')	goto yy38;
		if(yych >= '\r')	goto yy38;
		goto yy40;
	} else {
		if(yych <= ' '){
			if(yych >= ' ')	goto yy38;
			goto yy40;
		} else {
			if(yych == ':')	goto yy41;
			goto yy40;
		}
	}
yy40:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy3;
	case 2:	goto yy320;
	case 1:	goto yy24;
	}
yy41:	yych = *++YYCURSOR;
	goto yy42;
yy42:
#line 549 "./modules/parsers/gas/gas-token.re"
{
	    /* strip off colon and any whitespace */
	    count = TOKLEN-1;
	    while (s->tok[count] == ' ' || s->tok[count] == '\t'
		   || s->tok[count] == '\r')
		count--;
	    /* Just an identifier, return as such. */
	    lvalp->str_val = yasm__xstrndup(TOK, count);
	    RETURN(LABEL);
	}
#line 679 "gas-token.c"
yy43:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy44;
yy44:	if(yybm[0+yych] & 8) {
		goto yy43;
	}
	goto yy45;
yy45:
#line 521 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    switch (yasm_arch_parse_check_regtmod
		    (parser_gas->arch, lvalp->arch_data, TOK+1, TOKLEN-1)) {
		case YASM_ARCH_REG:
		    s->tok[TOKLEN] = savech;
		    RETURN(REG);
		case YASM_ARCH_REGGROUP:
		    s->tok[TOKLEN] = savech;
		    RETURN(REGGROUP);
		case YASM_ARCH_SEGREG:
		    s->tok[TOKLEN] = savech;
		    RETURN(SEGREG);
		default:
		    break;
	    }
	    yasm_error_set(YASM_ERROR_GENERAL,
			   N_("Unrecognized register name `%s'"), s->tok);
	    s->tok[TOKLEN] = savech;
	    lvalp->arch_data[0] = 0;
	    lvalp->arch_data[1] = 0;
	    lvalp->arch_data[2] = 0;
	    lvalp->arch_data[3] = 0;
	    RETURN(REG);
	}
#line 716 "gas-token.c"
yy46:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy47;
yy47:	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy19;
		} else {
			if(yych == '/')	goto yy19;
			goto yy46;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy19;
			if(yych <= 'Z')	goto yy46;
			goto yy19;
		} else {
			if(yych == '`')	goto yy19;
			if(yych <= 'z')	goto yy46;
			goto yy19;
		}
	}
yy48:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy305;
	goto yy47;
yy49:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy300;
	if(yych == 'b')	goto yy300;
	goto yy47;
yy50:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy295;
	if(yych == 'b')	goto yy295;
	goto yy47;
yy51:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy290;
	if(yych == 'b')	goto yy290;
	goto yy47;
yy52:	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == 'L')	goto yy278;
		if(yych <= 'R')	goto yy47;
		goto yy279;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy47;
			goto yy278;
		} else {
			if(yych == 's')	goto yy279;
			goto yy47;
		}
	}
yy53:	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= 'R'){
			if(yych == 'A')	goto yy265;
			goto yy47;
		} else {
			if(yych <= 'S')	goto yy267;
			if(yych <= 'X')	goto yy47;
			goto yy266;
		}
	} else {
		if(yych <= 'r'){
			if(yych == 'a')	goto yy265;
			goto yy47;
		} else {
			if(yych <= 's')	goto yy267;
			if(yych == 'y')	goto yy266;
			goto yy47;
		}
	}
yy54:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy250;
	if(yych == 'o')	goto yy250;
	goto yy47;
yy55:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'A')	goto yy241;
		if(yych <= 'N')	goto yy47;
		goto yy240;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy47;
			goto yy241;
		} else {
			if(yych == 'o')	goto yy240;
			goto yy47;
		}
	}
yy56:	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= 'P'){
			if(yych == 'N')	goto yy228;
			goto yy47;
		} else {
			if(yych <= 'Q')	goto yy229;
			if(yych <= 'W')	goto yy47;
			goto yy227;
		}
	} else {
		if(yych <= 'p'){
			if(yych == 'n')	goto yy228;
			goto yy47;
		} else {
			if(yych <= 'q')	goto yy229;
			if(yych == 'x')	goto yy227;
			goto yy47;
		}
	}
yy57:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'I')	goto yy217;
		if(yych <= 'K')	goto yy47;
		goto yy216;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy47;
			goto yy217;
		} else {
			if(yych == 'l')	goto yy216;
			goto yy47;
		}
	}
yy58:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy208;
	if(yych == 'l')	goto yy208;
	goto yy47;
yy59:	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy203;
	if(yych == 'w')	goto yy203;
	goto yy47;
yy60:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'D')	goto yy196;
		if(yych <= 'M')	goto yy47;
		goto yy195;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy47;
			goto yy196;
		} else {
			if(yych == 'n')	goto yy195;
			goto yy47;
		}
	}
yy61:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'H'){
			if(yych == 'C')	goto yy178;
			goto yy47;
		} else {
			if(yych <= 'I')	goto yy179;
			if(yych <= 'N')	goto yy47;
			goto yy177;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'c')	goto yy178;
			goto yy47;
		} else {
			if(yych <= 'i')	goto yy179;
			if(yych == 'o')	goto yy177;
			goto yy47;
		}
	}
yy62:	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'C')	goto yy171;
		if(yych <= 'Q')	goto yy47;
		goto yy170;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy47;
			goto yy171;
		} else {
			if(yych == 'r')	goto yy170;
			goto yy47;
		}
	}
yy63:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy163;
	goto yy47;
yy64:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy159;
	if(yych == 'u')	goto yy159;
	goto yy47;
yy65:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy155;
	if(yych == 'e')	goto yy155;
	goto yy47;
yy66:	yych = *++YYCURSOR;
	switch(yych){
	case 'E':	case 'e':	goto yy114;
	case 'H':	case 'h':	goto yy110;
	case 'I':	case 'i':	goto yy113;
	case 'K':	case 'k':	goto yy115;
	case 'L':	case 'l':	goto yy112;
	case 'P':	case 'p':	goto yy116;
	case 'T':	case 't':	goto yy111;
	default:	goto yy47;
	}
yy67:	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= 'E'){
			if(yych <= 'D')	goto yy47;
			goto yy97;
		} else {
			if(yych <= 'F')	goto yy96;
			if(yych <= 'X')	goto yy47;
			goto yy98;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'd')	goto yy47;
			if(yych <= 'e')	goto yy97;
			goto yy96;
		} else {
			if(yych == 'y')	goto yy98;
			goto yy47;
		}
	}
yy68:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy89;
	if(yych == 'l')	goto yy89;
	goto yy47;
yy69:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy84;
	if(yych == 'a')	goto yy84;
	goto yy47;
yy70:	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'E')	goto yy76;
		if(yych <= 'N')	goto yy47;
		goto yy77;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy47;
			goto yy76;
		} else {
			if(yych == 'o')	goto yy77;
			goto yy47;
		}
	}
yy71:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy72;
	if(yych != 'e')	goto yy47;
	goto yy72;
yy72:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy73;
	if(yych != 'r')	goto yy47;
	goto yy73;
yy73:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy74;
	if(yych != 'o')	goto yy47;
	goto yy74;
yy74:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy75;
		} else {
			if(yych != '/')	goto yy46;
			goto yy75;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy75;
			if(yych <= 'Z')	goto yy46;
			goto yy75;
		} else {
			if(yych == '`')	goto yy75;
			if(yych <= 'z')	goto yy46;
			goto yy75;
		}
	}
yy75:
#line 491 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_ZERO); }
#line 996 "gas-token.c"
yy76:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy81;
	if(yych == 'a')	goto yy81;
	goto yy47;
yy77:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy78;
	if(yych != 'r')	goto yy47;
	goto yy78;
yy78:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy79;
	if(yych != 'd')	goto yy47;
	goto yy79;
yy79:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy80;
		} else {
			if(yych != '/')	goto yy46;
			goto yy80;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy80;
			if(yych <= 'Z')	goto yy46;
			goto yy80;
		} else {
			if(yych == '`')	goto yy80;
			if(yych <= 'z')	goto yy46;
			goto yy80;
		}
	}
yy80:
#line 412 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = yasm_arch_wordsize(parser_gas->arch)/8;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1035 "gas-token.c"
yy81:	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy82;
	if(yych != 'k')	goto yy47;
	goto yy82;
yy82:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy83;
		} else {
			if(yych != '/')	goto yy46;
			goto yy83;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy83;
			if(yych <= 'Z')	goto yy46;
			goto yy83;
		} else {
			if(yych == '`')	goto yy83;
			if(yych <= 'z')	goto yy46;
			goto yy83;
		}
	}
yy83:
#line 374 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_WEAK); }
#line 1063 "gas-token.c"
yy84:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy85;
	if(yych != 'l')	goto yy47;
	goto yy85;
yy85:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy86;
	if(yych != 'u')	goto yy47;
	goto yy86;
yy86:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy87;
	if(yych != 'e')	goto yy47;
	goto yy87;
yy87:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy88;
		} else {
			if(yych != '/')	goto yy46;
			goto yy88;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy88;
			if(yych <= 'Z')	goto yy46;
			goto yy88;
		} else {
			if(yych == '`')	goto yy88;
			if(yych <= 'z')	goto yy46;
			goto yy88;
		}
	}
yy88:
#line 424 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 2; /* XXX: At least on x86, this is 2 bytes */
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1102 "gas-token.c"
yy89:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy90;
	if(yych != 'e')	goto yy47;
	goto yy90;
yy90:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy91;
	if(yych != 'b')	goto yy47;
	goto yy91;
yy91:	yych = *++YYCURSOR;
	if(yych != '1')	goto yy47;
	goto yy92;
yy92:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy47;
	goto yy93;
yy93:	yych = *++YYCURSOR;
	if(yych != '8')	goto yy47;
	goto yy94;
yy94:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy95;
		} else {
			if(yych != '/')	goto yy46;
			goto yy95;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy95;
			if(yych <= 'Z')	goto yy46;
			goto yy95;
		} else {
			if(yych == '`')	goto yy95;
			if(yych <= 'z')	goto yy46;
			goto yy95;
		}
	}
yy95:
#line 446 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 0; /* unsigned */
	    parser_gas->state = INSTDIR; RETURN(DIR_LEB128);
	}
#line 1146 "gas-token.c"
yy96:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy105;
	if(yych == 'l')	goto yy105;
	goto yy47;
yy97:	yych = *++YYCURSOR;
	if(yych == 'X')	goto yy102;
	if(yych == 'x')	goto yy102;
	goto yy47;
yy98:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy99;
	if(yych != 'p')	goto yy47;
	goto yy99;
yy99:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy100;
	if(yych != 'e')	goto yy47;
	goto yy100;
yy100:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy101;
		} else {
			if(yych != '/')	goto yy46;
			goto yy101;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy101;
			if(yych <= 'Z')	goto yy46;
			goto yy101;
		} else {
			if(yych == '`')	goto yy101;
			if(yych <= 'z')	goto yy46;
			goto yy101;
		}
	}
yy101:
#line 512 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_TYPE); }
#line 1186 "gas-token.c"
yy102:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy103;
	if(yych != 't')	goto yy47;
	goto yy103;
yy103:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy104;
		} else {
			if(yych != '/')	goto yy46;
			goto yy104;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy104;
			if(yych <= 'Z')	goto yy46;
			goto yy104;
		} else {
			if(yych == '`')	goto yy104;
			if(yych <= 'z')	goto yy46;
			goto yy104;
		}
	}
yy104:
#line 476 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->str_val = yasm__xstrdup(".text");
	    RETURN(DIR_SECTNAME);
	}
#line 1217 "gas-token.c"
yy105:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy106;
	if(yych != 'o')	goto yy47;
	goto yy106;
yy106:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy107;
	if(yych != 'a')	goto yy47;
	goto yy107;
yy107:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy108;
	if(yych != 't')	goto yy47;
	goto yy108;
yy108:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy109;
		} else {
			if(yych != '/')	goto yy46;
			goto yy109;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy109;
			if(yych <= 'Z')	goto yy46;
			goto yy109;
		} else {
			if(yych == '`')	goto yy109;
			if(yych <= 'z')	goto yy46;
			goto yy109;
		}
	}
yy109:
#line 463 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 10;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1256 "gas-token.c"
yy110:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy151;
	if(yych == 'o')	goto yy151;
	goto yy47;
yy111:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy146;
	if(yych == 'r')	goto yy146;
	goto yy47;
yy112:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy140;
	if(yych == 'e')	goto yy140;
	goto yy47;
yy113:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych == 'N')	goto yy132;
		if(yych <= 'Y')	goto yy47;
		goto yy133;
	} else {
		if(yych <= 'n'){
			if(yych <= 'm')	goto yy47;
			goto yy132;
		} else {
			if(yych == 'z')	goto yy133;
			goto yy47;
		}
	}
yy114:	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == 'C')	goto yy124;
		if(yych <= 'S')	goto yy47;
		goto yy125;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy47;
			goto yy124;
		} else {
			if(yych == 't')	goto yy125;
			goto yy47;
		}
	}
yy115:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy121;
	if(yych == 'i')	goto yy121;
	goto yy47;
yy116:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy117;
	if(yych != 'a')	goto yy47;
	goto yy117;
yy117:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy118;
	if(yych != 'c')	goto yy47;
	goto yy118;
yy118:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy119;
	if(yych != 'e')	goto yy47;
	goto yy119;
yy119:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy120;
		} else {
			if(yych != '/')	goto yy46;
			goto yy120;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy120;
			if(yych <= 'Z')	goto yy46;
			goto yy120;
		} else {
			if(yych == '`')	goto yy120;
			if(yych <= 'z')	goto yy46;
			goto yy120;
		}
	}
yy120:
#line 489 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_SKIP); }
#line 1336 "gas-token.c"
yy121:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy122;
	if(yych != 'p')	goto yy47;
	goto yy122;
yy122:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy123;
		} else {
			if(yych != '/')	goto yy46;
			goto yy123;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy123;
			if(yych <= 'Z')	goto yy46;
			goto yy123;
		} else {
			if(yych == '`')	goto yy123;
			if(yych <= 'z')	goto yy46;
			goto yy123;
		}
	}
yy123:
#line 488 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_SKIP); }
#line 1364 "gas-token.c"
yy124:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy127;
	if(yych == 't')	goto yy127;
	goto yy47;
yy125:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy126;
		} else {
			if(yych != '/')	goto yy46;
			goto yy126;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy126;
			if(yych <= 'Z')	goto yy46;
			goto yy126;
		} else {
			if(yych == '`')	goto yy126;
			if(yych <= 'z')	goto yy46;
			goto yy126;
		}
	}
yy126:
#line 510 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_EQU); }
#line 1392 "gas-token.c"
yy127:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy128;
	if(yych != 'i')	goto yy47;
	goto yy128;
yy128:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy129;
	if(yych != 'o')	goto yy47;
	goto yy129;
yy129:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy130;
	if(yych != 'n')	goto yy47;
	goto yy130;
yy130:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy131;
		} else {
			if(yych != '/')	goto yy46;
			goto yy131;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy131;
			if(yych <= 'Z')	goto yy46;
			goto yy131;
		} else {
			if(yych == '`')	goto yy131;
			if(yych <= 'z')	goto yy46;
			goto yy131;
		}
	}
yy131:
#line 480 "./modules/parsers/gas/gas-token.re"
{
	    parser_gas->state = SECTION_DIRECTIVE;
	    RETURN(DIR_SECTION);
	}
#line 1431 "gas-token.c"
yy132:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy136;
	if(yych == 'g')	goto yy136;
	goto yy47;
yy133:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy134;
	if(yych != 'e')	goto yy47;
	goto yy134;
yy134:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy135;
		} else {
			if(yych != '/')	goto yy46;
			goto yy135;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy135;
			if(yych <= 'Z')	goto yy46;
			goto yy135;
		} else {
			if(yych == '`')	goto yy135;
			if(yych <= 'z')	goto yy46;
			goto yy135;
		}
	}
yy135:
#line 511 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_SIZE); }
#line 1463 "gas-token.c"
yy136:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy137;
	if(yych != 'l')	goto yy47;
	goto yy137;
yy137:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy138;
	if(yych != 'e')	goto yy47;
	goto yy138;
yy138:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy139;
		} else {
			if(yych != '/')	goto yy46;
			goto yy139;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy139;
			if(yych <= 'Z')	goto yy46;
			goto yy139;
		} else {
			if(yych == '`')	goto yy139;
			if(yych <= 'z')	goto yy46;
			goto yy139;
		}
	}
yy139:
#line 455 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 4;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1498 "gas-token.c"
yy140:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy141;
	if(yych != 'b')	goto yy47;
	goto yy141;
yy141:	yych = *++YYCURSOR;
	if(yych != '1')	goto yy47;
	goto yy142;
yy142:	yych = *++YYCURSOR;
	if(yych != '2')	goto yy47;
	goto yy143;
yy143:	yych = *++YYCURSOR;
	if(yych != '8')	goto yy47;
	goto yy144;
yy144:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy145;
		} else {
			if(yych != '/')	goto yy46;
			goto yy145;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy145;
			if(yych <= 'Z')	goto yy46;
			goto yy145;
		} else {
			if(yych == '`')	goto yy145;
			if(yych <= 'z')	goto yy46;
			goto yy145;
		}
	}
yy145:
#line 442 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 1; /* signed */
	    parser_gas->state = INSTDIR; RETURN(DIR_LEB128);
	}
#line 1538 "gas-token.c"
yy146:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy147;
	if(yych != 'i')	goto yy47;
	goto yy147;
yy147:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy148;
	if(yych != 'n')	goto yy47;
	goto yy148;
yy148:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy149;
	if(yych != 'g')	goto yy47;
	goto yy149;
yy149:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy150;
		} else {
			if(yych != '/')	goto yy46;
			goto yy150;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy150;
			if(yych <= 'Z')	goto yy46;
			goto yy150;
		} else {
			if(yych == '`')	goto yy150;
			if(yych <= 'z')	goto yy46;
			goto yy150;
		}
	}
yy150:
#line 437 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 1; /* add terminating zero */
	    parser_gas->state = INSTDIR; RETURN(DIR_ASCII);
	}
#line 1577 "gas-token.c"
yy151:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy152;
	if(yych != 'r')	goto yy47;
	goto yy152;
yy152:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy153;
	if(yych != 't')	goto yy47;
	goto yy153;
yy153:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy154;
		} else {
			if(yych != '/')	goto yy46;
			goto yy154;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy154;
			if(yych <= 'Z')	goto yy46;
			goto yy154;
		} else {
			if(yych == '`')	goto yy154;
			if(yych <= 'z')	goto yy46;
			goto yy154;
		}
	}
yy154:
#line 396 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 2; /* TODO: This should depend on arch */
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1612 "gas-token.c"
yy155:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy156;
	if(yych != 'p')	goto yy47;
	goto yy156;
yy156:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy157;
	if(yych != 't')	goto yy47;
	goto yy157;
yy157:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy158;
		} else {
			if(yych != '/')	goto yy46;
			goto yy158;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy158;
			if(yych <= 'Z')	goto yy46;
			goto yy158;
		} else {
			if(yych == '`')	goto yy158;
			if(yych <= 'z')	goto yy46;
			goto yy158;
		}
	}
yy158:
#line 485 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_REPT); }
#line 1644 "gas-token.c"
yy159:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy160;
	if(yych != 'a')	goto yy47;
	goto yy160;
yy160:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy161;
	if(yych != 'd')	goto yy47;
	goto yy161;
yy161:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy162;
		} else {
			if(yych != '/')	goto yy46;
			goto yy162;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy162;
			if(yych <= 'Z')	goto yy46;
			goto yy162;
		} else {
			if(yych == '`')	goto yy162;
			if(yych <= 'z')	goto yy46;
			goto yy162;
		}
	}
yy162:
#line 416 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 8;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1679 "gas-token.c"
yy163:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy164;
	if(yych != 'a')	goto yy47;
	goto yy164;
yy164:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy165;
	if(yych != 'l')	goto yy47;
	goto yy165;
yy165:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy166;
	if(yych != 'i')	goto yy47;
	goto yy166;
yy166:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy167;
	if(yych != 'g')	goto yy47;
	goto yy167;
yy167:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy168;
	if(yych != 'n')	goto yy47;
	goto yy168;
yy168:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy169;
		} else {
			if(yych != '/')	goto yy46;
			goto yy169;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy169;
			if(yych <= 'Z')	goto yy46;
			goto yy169;
		} else {
			if(yych == '`')	goto yy169;
			if(yych <= 'z')	goto yy46;
			goto yy169;
		}
	}
yy169:
#line 358 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 1;
	    parser_gas->state = INSTDIR; RETURN(DIR_ALIGN);
	}
#line 1726 "gas-token.c"
yy170:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy175;
	if(yych == 'g')	goto yy175;
	goto yy47;
yy171:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy172;
	if(yych != 't')	goto yy47;
	goto yy172;
yy172:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy173;
	if(yych != 'a')	goto yy47;
	goto yy173;
yy173:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy174;
		} else {
			if(yych != '/')	goto yy46;
			goto yy174;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy174;
			if(yych <= 'Z')	goto yy46;
			goto yy174;
		} else {
			if(yych == '`')	goto yy174;
			if(yych <= 'z')	goto yy46;
			goto yy174;
		}
	}
yy174:
#line 420 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 16;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1765 "gas-token.c"
yy175:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy176;
		} else {
			if(yych != '/')	goto yy46;
			goto yy176;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy176;
			if(yych <= 'Z')	goto yy46;
			goto yy176;
		} else {
			if(yych == '`')	goto yy176;
			if(yych <= 'z')	goto yy46;
			goto yy176;
		}
	}
yy176:
#line 366 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_ORG); }
#line 1789 "gas-token.c"
yy177:	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'C')	goto yy187;
		if(yych <= 'M')	goto yy47;
		goto yy189;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy47;
			goto yy187;
		} else {
			if(yych == 'n')	goto yy189;
			goto yy47;
		}
	}
yy178:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy183;
	if(yych == 'o')	goto yy183;
	goto yy47;
yy179:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy180;
	if(yych != 'n')	goto yy47;
	goto yy180;
yy180:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy181;
	if(yych != 'e')	goto yy47;
	goto yy181;
yy181:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy182;
		} else {
			if(yych != '/')	goto yy46;
			goto yy182;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy182;
			if(yych <= 'Z')	goto yy46;
			goto yy182;
		} else {
			if(yych == '`')	goto yy182;
			if(yych <= 'z')	goto yy46;
			goto yy182;
		}
	}
yy182:
#line 508 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_LINE); }
#line 1839 "gas-token.c"
yy183:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy184;
	if(yych != 'm')	goto yy47;
	goto yy184;
yy184:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy185;
	if(yych != 'm')	goto yy47;
	goto yy185;
yy185:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy186;
		} else {
			if(yych != '/')	goto yy46;
			goto yy186;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy186;
			if(yych <= 'Z')	goto yy46;
			goto yy186;
		} else {
			if(yych == '`')	goto yy186;
			if(yych <= 'z')	goto yy46;
			goto yy186;
		}
	}
yy186:
#line 372 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_LCOMM); }
#line 1871 "gas-token.c"
yy187:	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy188;
		} else {
			if(yych == '/')	goto yy188;
			if(yych <= '9')	goto yy46;
			goto yy188;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'A')	goto yy192;
			if(yych <= 'Z')	goto yy46;
			if(yych >= '_')	goto yy46;
			goto yy188;
		} else {
			if(yych <= '`')	goto yy188;
			if(yych <= 'a')	goto yy192;
			if(yych <= 'z')	goto yy46;
			goto yy188;
		}
	}
yy188:
#line 509 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_LOC); }
#line 1898 "gas-token.c"
yy189:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy190;
	if(yych != 'g')	goto yy47;
	goto yy190;
yy190:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy191;
		} else {
			if(yych != '/')	goto yy46;
			goto yy191;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy191;
			if(yych <= 'Z')	goto yy46;
			goto yy191;
		} else {
			if(yych == '`')	goto yy191;
			if(yych <= 'z')	goto yy46;
			goto yy191;
		}
	}
yy191:
#line 404 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 4; /* TODO: This should depend on arch */
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 1929 "gas-token.c"
yy192:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy193;
	if(yych != 'l')	goto yy47;
	goto yy193;
yy193:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy194;
		} else {
			if(yych != '/')	goto yy46;
			goto yy194;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy194;
			if(yych <= 'Z')	goto yy46;
			goto yy194;
		} else {
			if(yych == '`')	goto yy194;
			if(yych <= 'z')	goto yy46;
			goto yy194;
		}
	}
yy194:
#line 368 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_LOCAL); }
#line 1957 "gas-token.c"
yy195:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy201;
	if(yych == 't')	goto yy201;
	goto yy47;
yy196:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy197;
	if(yych != 'e')	goto yy47;
	goto yy197;
yy197:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy198;
	if(yych != 'n')	goto yy47;
	goto yy198;
yy198:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy199;
	if(yych != 't')	goto yy47;
	goto yy199;
yy199:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy200;
		} else {
			if(yych != '/')	goto yy46;
			goto yy200;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy200;
			if(yych <= 'Z')	goto yy46;
			goto yy200;
		} else {
			if(yych == '`')	goto yy200;
			if(yych <= 'z')	goto yy46;
			goto yy200;
		}
	}
yy200:
#line 507 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_IDENT); }
#line 1997 "gas-token.c"
yy201:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy202;
		} else {
			if(yych != '/')	goto yy46;
			goto yy202;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy202;
			if(yych <= 'Z')	goto yy46;
			goto yy202;
		} else {
			if(yych == '`')	goto yy202;
			if(yych <= 'z')	goto yy46;
			goto yy202;
		}
	}
yy202:
#line 400 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 4; /* TODO: This should depend on arch */
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2024 "gas-token.c"
yy203:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy204;
	if(yych != 'o')	goto yy47;
	goto yy204;
yy204:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy205;
	if(yych != 'r')	goto yy47;
	goto yy205;
yy205:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy206;
	if(yych != 'd')	goto yy47;
	goto yy206;
yy206:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy207;
		} else {
			if(yych != '/')	goto yy46;
			goto yy207;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy207;
			if(yych <= 'Z')	goto yy46;
			goto yy207;
		} else {
			if(yych == '`')	goto yy207;
			if(yych <= 'z')	goto yy46;
			goto yy207;
		}
	}
yy207:
#line 408 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 2; /* TODO: This should depend on arch */
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2063 "gas-token.c"
yy208:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy209;
	if(yych != 'o')	goto yy47;
	goto yy209;
yy209:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy210;
	if(yych != 'b')	goto yy47;
	goto yy210;
yy210:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'A')	goto yy211;
		if(yych <= 'K')	goto yy47;
		goto yy212;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy47;
			goto yy211;
		} else {
			if(yych == 'l')	goto yy212;
			goto yy47;
		}
	}
yy211:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy214;
	if(yych == 'l')	goto yy214;
	goto yy47;
yy212:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy213;
		} else {
			if(yych != '/')	goto yy46;
			goto yy213;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy213;
			if(yych <= 'Z')	goto yy46;
			goto yy213;
		} else {
			if(yych == '`')	goto yy213;
			if(yych <= 'z')	goto yy46;
			goto yy213;
		}
	}
yy213:
#line 370 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_GLOBAL); }
#line 2113 "gas-token.c"
yy214:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy215;
		} else {
			if(yych != '/')	goto yy46;
			goto yy215;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy215;
			if(yych <= 'Z')	goto yy46;
			goto yy215;
		} else {
			if(yych == '`')	goto yy215;
			if(yych <= 'z')	goto yy46;
			goto yy215;
		}
	}
yy215:
#line 369 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_GLOBAL); }
#line 2137 "gas-token.c"
yy216:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy223;
	if(yych == 'o')	goto yy223;
	goto yy47;
yy217:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy218;
	if(yych != 'l')	goto yy47;
	goto yy218;
yy218:	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych == 'E')	goto yy221;
		if(yych <= 'K')	goto yy47;
		goto yy219;
	} else {
		if(yych <= 'e'){
			if(yych <= 'd')	goto yy47;
			goto yy221;
		} else {
			if(yych != 'l')	goto yy47;
			goto yy219;
		}
	}
yy219:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy220;
		} else {
			if(yych != '/')	goto yy46;
			goto yy220;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy220;
			if(yych <= 'Z')	goto yy46;
			goto yy220;
		} else {
			if(yych == '`')	goto yy220;
			if(yych <= 'z')	goto yy46;
			goto yy220;
		}
	}
yy220:
#line 490 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_FILL); }
#line 2183 "gas-token.c"
yy221:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy222;
		} else {
			if(yych != '/')	goto yy46;
			goto yy222;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy222;
			if(yych <= 'Z')	goto yy46;
			goto yy222;
		} else {
			if(yych == '`')	goto yy222;
			if(yych <= 'z')	goto yy46;
			goto yy222;
		}
	}
yy222:
#line 506 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_FILE); }
#line 2207 "gas-token.c"
yy223:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy224;
	if(yych != 'a')	goto yy47;
	goto yy224;
yy224:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy225;
	if(yych != 't')	goto yy47;
	goto yy225;
yy225:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy226;
		} else {
			if(yych != '/')	goto yy46;
			goto yy226;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy226;
			if(yych <= 'Z')	goto yy46;
			goto yy226;
		} else {
			if(yych == '`')	goto yy226;
			if(yych <= 'z')	goto yy46;
			goto yy226;
		}
	}
yy226:
#line 451 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 4;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2242 "gas-token.c"
yy227:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy235;
	if(yych == 't')	goto yy235;
	goto yy47;
yy228:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy232;
	if(yych == 'd')	goto yy232;
	goto yy47;
yy229:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy230;
	if(yych != 'u')	goto yy47;
	goto yy230;
yy230:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy231;
		} else {
			if(yych != '/')	goto yy46;
			goto yy231;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy231;
			if(yych <= 'Z')	goto yy46;
			goto yy231;
		} else {
			if(yych == '`')	goto yy231;
			if(yych <= 'z')	goto yy46;
			goto yy231;
		}
	}
yy231:
#line 505 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_EQU); }
#line 2278 "gas-token.c"
yy232:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy233;
	if(yych != 'r')	goto yy47;
	goto yy233;
yy233:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy234;
		} else {
			if(yych != '/')	goto yy46;
			goto yy234;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy234;
			if(yych <= 'Z')	goto yy46;
			goto yy234;
		} else {
			if(yych == '`')	goto yy234;
			if(yych <= 'z')	goto yy46;
			goto yy234;
		}
	}
yy234:
#line 486 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_ENDR); }
#line 2306 "gas-token.c"
yy235:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy236;
	if(yych != 'e')	goto yy47;
	goto yy236;
yy236:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy237;
	if(yych != 'r')	goto yy47;
	goto yy237;
yy237:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy238;
	if(yych != 'n')	goto yy47;
	goto yy238;
yy238:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy239;
		} else {
			if(yych != '/')	goto yy46;
			goto yy239;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy239;
			if(yych <= 'Z')	goto yy46;
			goto yy239;
		} else {
			if(yych == '`')	goto yy239;
			if(yych <= 'z')	goto yy46;
			goto yy239;
		}
	}
yy239:
#line 373 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_EXTERN); }
#line 2342 "gas-token.c"
yy240:	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy245;
	if(yych == 'u')	goto yy245;
	goto yy47;
yy241:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy242;
	if(yych != 't')	goto yy47;
	goto yy242;
yy242:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy243;
	if(yych != 'a')	goto yy47;
	goto yy243;
yy243:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy244;
		} else {
			if(yych != '/')	goto yy46;
			goto yy244;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy244;
			if(yych <= 'Z')	goto yy46;
			goto yy244;
		} else {
			if(yych == '`')	goto yy244;
			if(yych <= 'z')	goto yy46;
			goto yy244;
		}
	}
yy244:
#line 472 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->str_val = yasm__xstrdup(".data");
	    RETURN(DIR_SECTNAME);
	}
#line 2381 "gas-token.c"
yy245:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy246;
	if(yych != 'b')	goto yy47;
	goto yy246;
yy246:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy247;
	if(yych != 'l')	goto yy47;
	goto yy247;
yy247:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy248;
	if(yych != 'e')	goto yy47;
	goto yy248;
yy248:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy249;
		} else {
			if(yych != '/')	goto yy46;
			goto yy249;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy249;
			if(yych <= 'Z')	goto yy46;
			goto yy249;
		} else {
			if(yych == '`')	goto yy249;
			if(yych <= 'z')	goto yy46;
			goto yy249;
		}
	}
yy249:
#line 459 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 8;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2420 "gas-token.c"
yy250:	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == 'D')	goto yy251;
		if(yych <= 'L')	goto yy47;
		goto yy252;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy47;
			goto yy251;
		} else {
			if(yych == 'm')	goto yy252;
			goto yy47;
		}
	}
yy251:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy255;
	if(yych == 'e')	goto yy255;
	goto yy47;
yy252:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy253;
	if(yych != 'm')	goto yy47;
	goto yy253;
yy253:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy254;
		} else {
			if(yych != '/')	goto yy46;
			goto yy254;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy254;
			if(yych <= 'Z')	goto yy46;
			goto yy254;
		} else {
			if(yych == '`')	goto yy254;
			if(yych <= 'z')	goto yy46;
			goto yy254;
		}
	}
yy254:
#line 371 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INSTDIR; RETURN(DIR_COMM); }
#line 2466 "gas-token.c"
yy255:	yych = *++YYCURSOR;
	if(yych <= '2'){
		if(yych != '1')	goto yy47;
		goto yy256;
	} else {
		if(yych <= '3')	goto yy257;
		if(yych == '6')	goto yy258;
		goto yy47;
	}
yy256:	yych = *++YYCURSOR;
	if(yych == '6')	goto yy263;
	goto yy47;
yy257:	yych = *++YYCURSOR;
	if(yych == '2')	goto yy261;
	goto yy47;
yy258:	yych = *++YYCURSOR;
	if(yych != '4')	goto yy47;
	goto yy259;
yy259:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy260;
		} else {
			if(yych != '/')	goto yy46;
			goto yy260;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy260;
			if(yych <= 'Z')	goto yy46;
			goto yy260;
		} else {
			if(yych == '`')	goto yy260;
			if(yych <= 'z')	goto yy46;
			goto yy260;
		}
	}
yy260:
#line 501 "./modules/parsers/gas/gas-token.re"
{
	    yasm_arch_set_var(parser_gas->arch, "mode_bits", 64);
	    goto scan;
	}
#line 2511 "gas-token.c"
yy261:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy262;
		} else {
			if(yych != '/')	goto yy46;
			goto yy262;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy262;
			if(yych <= 'Z')	goto yy46;
			goto yy262;
		} else {
			if(yych == '`')	goto yy262;
			if(yych <= 'z')	goto yy46;
			goto yy262;
		}
	}
yy262:
#line 497 "./modules/parsers/gas/gas-token.re"
{
	    yasm_arch_set_var(parser_gas->arch, "mode_bits", 32);
	    goto scan;
	}
#line 2538 "gas-token.c"
yy263:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy264;
		} else {
			if(yych != '/')	goto yy46;
			goto yy264;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy264;
			if(yych <= 'Z')	goto yy46;
			goto yy264;
		} else {
			if(yych == '`')	goto yy264;
			if(yych <= 'z')	goto yy46;
			goto yy264;
		}
	}
yy264:
#line 493 "./modules/parsers/gas/gas-token.re"
{
	    yasm_arch_set_var(parser_gas->arch, "mode_bits", 16);
	    goto scan;
	}
#line 2565 "gas-token.c"
yy265:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy273;
	if(yych == 'l')	goto yy273;
	goto yy47;
yy266:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy270;
	if(yych == 't')	goto yy270;
	goto yy47;
yy267:	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy268;
	if(yych != 's')	goto yy47;
	goto yy268;
yy268:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy269;
		} else {
			if(yych != '/')	goto yy46;
			goto yy269;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy269;
			if(yych <= 'Z')	goto yy46;
			goto yy269;
		} else {
			if(yych == '`')	goto yy269;
			if(yych <= 'z')	goto yy46;
			goto yy269;
		}
	}
yy269:
#line 468 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->str_val = yasm__xstrdup(".bss");
	    RETURN(DIR_SECTNAME);
	}
#line 2604 "gas-token.c"
yy270:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy271;
	if(yych != 'e')	goto yy47;
	goto yy271;
yy271:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy272;
		} else {
			if(yych != '/')	goto yy46;
			goto yy272;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy272;
			if(yych <= 'Z')	goto yy46;
			goto yy272;
		} else {
			if(yych == '`')	goto yy272;
			if(yych <= 'z')	goto yy46;
			goto yy272;
		}
	}
yy272:
#line 376 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 1;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2635 "gas-token.c"
yy273:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy274;
	if(yych != 'i')	goto yy47;
	goto yy274;
yy274:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy275;
	if(yych != 'g')	goto yy47;
	goto yy275;
yy275:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy276;
	if(yych != 'n')	goto yy47;
	goto yy276;
yy276:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy277;
		} else {
			if(yych != '/')	goto yy46;
			goto yy277;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy277;
			if(yych <= 'Z')	goto yy46;
			goto yy277;
		} else {
			if(yych == '`')	goto yy277;
			if(yych <= 'z')	goto yy46;
			goto yy277;
		}
	}
yy277:
#line 362 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 0;
	    parser_gas->state = INSTDIR; RETURN(DIR_ALIGN);
	}
#line 2674 "gas-token.c"
yy278:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy286;
	if(yych == 'i')	goto yy286;
	goto yy47;
yy279:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy280;
	if(yych != 'c')	goto yy47;
	goto yy280;
yy280:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy281;
	if(yych != 'i')	goto yy47;
	goto yy281;
yy281:	yych = *++YYCURSOR;
	if(yych <= 'Z'){
		if(yych == 'I')	goto yy282;
		if(yych <= 'Y')	goto yy47;
		goto yy284;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy47;
			goto yy282;
		} else {
			if(yych == 'z')	goto yy284;
			goto yy47;
		}
	}
yy282:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy283;
		} else {
			if(yych != '/')	goto yy46;
			goto yy283;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy283;
			if(yych <= 'Z')	goto yy46;
			goto yy283;
		} else {
			if(yych == '`')	goto yy283;
			if(yych <= 'z')	goto yy46;
			goto yy283;
		}
	}
yy283:
#line 429 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 0; /* do not add terminating zero */
	    parser_gas->state = INSTDIR; RETURN(DIR_ASCII);
	}
#line 2727 "gas-token.c"
yy284:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy285;
		} else {
			if(yych != '/')	goto yy46;
			goto yy285;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy285;
			if(yych <= 'Z')	goto yy46;
			goto yy285;
		} else {
			if(yych == '`')	goto yy285;
			if(yych <= 'z')	goto yy46;
			goto yy285;
		}
	}
yy285:
#line 433 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 1; /* add terminating zero */
	    parser_gas->state = INSTDIR; RETURN(DIR_ASCII);
	}
#line 2754 "gas-token.c"
yy286:	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy287;
	if(yych != 'g')	goto yy47;
	goto yy287;
yy287:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy288;
	if(yych != 'n')	goto yy47;
	goto yy288;
yy288:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy289;
		} else {
			if(yych != '/')	goto yy46;
			goto yy289;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy289;
			if(yych <= 'Z')	goto yy46;
			goto yy289;
		} else {
			if(yych == '`')	goto yy289;
			if(yych <= 'z')	goto yy46;
			goto yy289;
		}
	}
yy289:
#line 351 "./modules/parsers/gas/gas-token.re"
{
	    /* FIXME: Whether this is power-of-two or not depends on arch and
	     * objfmt.
	     */
	    lvalp->int_info = 0;
	    parser_gas->state = INSTDIR; RETURN(DIR_ALIGN);
	}
#line 2792 "gas-token.c"
yy290:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy291;
	if(yych != 'y')	goto yy47;
	goto yy291;
yy291:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy292;
	if(yych != 't')	goto yy47;
	goto yy292;
yy292:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy293;
	if(yych != 'e')	goto yy47;
	goto yy293;
yy293:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy294;
		} else {
			if(yych != '/')	goto yy46;
			goto yy294;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy294;
			if(yych <= 'Z')	goto yy46;
			goto yy294;
		} else {
			if(yych == '`')	goto yy294;
			if(yych <= 'z')	goto yy46;
			goto yy294;
		}
	}
yy294:
#line 388 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 8;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2831 "gas-token.c"
yy295:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy296;
	if(yych != 'y')	goto yy47;
	goto yy296;
yy296:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy297;
	if(yych != 't')	goto yy47;
	goto yy297;
yy297:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy298;
	if(yych != 'e')	goto yy47;
	goto yy298;
yy298:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy299;
		} else {
			if(yych != '/')	goto yy46;
			goto yy299;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy299;
			if(yych <= 'Z')	goto yy46;
			goto yy299;
		} else {
			if(yych == '`')	goto yy299;
			if(yych <= 'z')	goto yy46;
			goto yy299;
		}
	}
yy299:
#line 384 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 4;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2870 "gas-token.c"
yy300:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy301;
	if(yych != 'y')	goto yy47;
	goto yy301;
yy301:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy302;
	if(yych != 't')	goto yy47;
	goto yy302;
yy302:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy303;
	if(yych != 'e')	goto yy47;
	goto yy303;
yy303:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy304;
		} else {
			if(yych != '/')	goto yy46;
			goto yy304;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy304;
			if(yych <= 'Z')	goto yy46;
			goto yy304;
		} else {
			if(yych == '`')	goto yy304;
			if(yych <= 'z')	goto yy46;
			goto yy304;
		}
	}
yy304:
#line 380 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 2;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2909 "gas-token.c"
yy305:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy306;
	if(yych != 'b')	goto yy47;
	goto yy306;
yy306:	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy307;
	if(yych != 'y')	goto yy47;
	goto yy307;
yy307:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy308;
	if(yych != 't')	goto yy47;
	goto yy308;
yy308:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy309;
	if(yych != 'e')	goto yy47;
	goto yy309;
yy309:	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == '$')	goto yy46;
			goto yy310;
		} else {
			if(yych != '/')	goto yy46;
			goto yy310;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '@')	goto yy310;
			if(yych <= 'Z')	goto yy46;
			goto yy310;
		} else {
			if(yych == '`')	goto yy310;
			if(yych <= 'z')	goto yy46;
			goto yy310;
		}
	}
yy310:
#line 392 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->int_info = 16;
	    parser_gas->state = INSTDIR; RETURN(DIR_DATA);
	}
#line 2952 "gas-token.c"
yy311:	yych = *++YYCURSOR;
	goto yy312;
yy312:
#line 588 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = COMMENT; goto comment; }
#line 2958 "gas-token.c"
yy313:	yych = *++YYCURSOR;
	goto yy314;
yy314:
#line 340 "./modules/parsers/gas/gas-token.re"
{ RETURN(RIGHT_OP); }
#line 2964 "gas-token.c"
yy315:	yych = *++YYCURSOR;
	goto yy316;
yy316:
#line 339 "./modules/parsers/gas/gas-token.re"
{ RETURN(LEFT_OP); }
#line 2970 "gas-token.c"
yy317:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy318;
yy318:	if(yybm[0+yych] & 16) {
		goto yy317;
	}
	goto yy3;
yy319:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '+')	goto yy332;
	if(yych == '-')	goto yy332;
	goto yy333;
yy320:
#line 320 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    lvalp->flt = yasm_floatnum_create(TOK+2);
	    s->tok[TOKLEN] = savech;
	    RETURN(FLTNUM);
	}
#line 2993 "gas-token.c"
yy321:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy329;
	}
	goto yy40;
yy322:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy323;
yy323:	if(yybm[0+yych] & 32) {
		goto yy322;
	}
	goto yy324;
yy324:
#line 301 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    lvalp->intn = yasm_intnum_create_oct(TOK);
	    s->tok[TOKLEN] = savech;
	    RETURN(INTNUM);
	}
#line 3016 "gas-token.c"
yy325:	yych = *++YYCURSOR;
	if(yybm[0+yych] & 64) {
		goto yy326;
	}
	goto yy40;
yy326:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy327;
yy327:	if(yybm[0+yych] & 64) {
		goto yy326;
	}
	goto yy328;
yy328:
#line 292 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    lvalp->intn = yasm_intnum_create_bin(TOK+2);
	    s->tok[TOKLEN] = savech;
	    RETURN(INTNUM);
	}
#line 3039 "gas-token.c"
yy329:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy330;
yy330:	if(yybm[0+yych] & 128) {
		goto yy329;
	}
	goto yy331;
yy331:
#line 310 "./modules/parsers/gas/gas-token.re"
{
	    savech = s->tok[TOKLEN];
	    s->tok[TOKLEN] = '\0';
	    /* skip 0 and x */
	    lvalp->intn = yasm_intnum_create_hex(TOK+2);
	    s->tok[TOKLEN] = savech;
	    RETURN(INTNUM);
	}
#line 3058 "gas-token.c"
yy332:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy333;
yy333:	if(yych <= '9'){
		if(yych == '.')	goto yy334;
		if(yych <= '/')	goto yy320;
		goto yy332;
	} else {
		if(yych <= 'E'){
			if(yych <= 'D')	goto yy320;
			goto yy336;
		} else {
			if(yych == 'e')	goto yy336;
			goto yy320;
		}
	}
yy334:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	goto yy335;
yy335:	if(yych <= 'D'){
		if(yych <= '/')	goto yy320;
		if(yych <= '9')	goto yy334;
		goto yy320;
	} else {
		if(yych <= 'E')	goto yy336;
		if(yych != 'e')	goto yy320;
		goto yy336;
	}
yy336:	yych = *++YYCURSOR;
	if(yych <= ','){
		if(yych != '+')	goto yy40;
		goto yy337;
	} else {
		if(yych <= '-')	goto yy337;
		if(yych <= '/')	goto yy40;
		if(yych <= '9')	goto yy338;
		goto yy40;
	}
yy337:	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy40;
	if(yych >= ':')	goto yy40;
	goto yy338;
yy338:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy339;
yy339:	if(yych <= '/')	goto yy320;
	if(yych <= '9')	goto yy338;
	goto yy320;
}
}
#line 606 "./modules/parsers/gas/gas-token.re"


    /* C-style comment; nesting not supported */
comment:
    SCANINIT();

    {

#line 3123 "gas-token.c"
{
	YYCTYPE yych;
	goto yy340;
	++YYCURSOR;
yy340:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych == '\n')	goto yy344;
	if(yych != '*')	goto yy346;
	goto yy342;
yy342:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy347;
	goto yy343;
yy343:
#line 622 "./modules/parsers/gas/gas-token.re"
{
	    if (cursor == s->eof)
		return 0;
	    goto comment;
	}
#line 3144 "gas-token.c"
yy344:	yych = *++YYCURSOR;
	goto yy345;
yy345:
#line 616 "./modules/parsers/gas/gas-token.re"
{
	    if (parser_gas->save_input)
		cursor = save_line(parser_gas, cursor);
	    RETURN(s->tok[0]);
	}
#line 3154 "gas-token.c"
yy346:	yych = *++YYCURSOR;
	goto yy343;
yy347:	yych = *++YYCURSOR;
	goto yy348;
yy348:
#line 614 "./modules/parsers/gas/gas-token.re"
{ parser_gas->state = INITIAL; goto scan; }
#line 3162 "gas-token.c"
}
}
#line 627 "./modules/parsers/gas/gas-token.re"


    /* .section directive (the section name portion thereof) */
section_directive:
    SCANINIT();

    {
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,  64,   0,   0,   0,  64,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	 64,   0,   0,   0, 128,   0,   0,   0, 
	  0,   0,   0,   0,   0, 128, 128,   0, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0,   0,   0,   0,   0,   0, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0, 128, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 3208 "gas-token.c"
{
	YYCTYPE yych;
	goto yy349;
	++YYCURSOR;
yy349:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= '$'){
		if(yych <= '\r'){
			if(yych <= '\t'){
				if(yych <= '\b')	goto yy361;
				goto yy355;
			} else {
				if(yych <= '\n')	goto yy359;
				if(yych <= '\f')	goto yy361;
				goto yy355;
			}
		} else {
			if(yych <= '!'){
				if(yych == ' ')	goto yy355;
				goto yy361;
			} else {
				if(yych <= '"')	goto yy353;
				if(yych <= '#')	goto yy361;
				goto yy351;
			}
		}
	} else {
		if(yych <= '@'){
			if(yych <= '.'){
				if(yych <= '+')	goto yy361;
				if(yych <= ',')	goto yy357;
				goto yy351;
			} else {
				if(yych <= '/')	goto yy361;
				if(yych >= ':')	goto yy361;
				goto yy351;
			}
		} else {
			if(yych <= '_'){
				if(yych <= 'Z')	goto yy351;
				if(yych <= '^')	goto yy361;
				goto yy351;
			} else {
				if(yych <= '`')	goto yy361;
				if(yych >= '{')	goto yy361;
				goto yy351;
			}
		}
	}
yy351:	yych = *++YYCURSOR;
	goto yy366;
yy352:
#line 634 "./modules/parsers/gas/gas-token.re"
{
	    lvalp->str_val = yasm__xstrndup(TOK, TOKLEN);
	    parser_gas->state = INITIAL;
	    RETURN(ID);
	}
#line 3268 "gas-token.c"
yy353:	yych = *++YYCURSOR;
	goto yy354;
yy354:
#line 640 "./modules/parsers/gas/gas-token.re"
{ goto stringconst; }
#line 3274 "gas-token.c"
yy355:	yych = *++YYCURSOR;
	goto yy364;
yy356:
#line 642 "./modules/parsers/gas/gas-token.re"
{ goto section_directive; }
#line 3280 "gas-token.c"
yy357:	yych = *++YYCURSOR;
	goto yy358;
yy358:
#line 644 "./modules/parsers/gas/gas-token.re"
{
	    parser_gas->state = INITIAL;
	    RETURN(s->tok[0]);
	}
#line 3289 "gas-token.c"
yy359:	yych = *++YYCURSOR;
	goto yy360;
yy360:
#line 649 "./modules/parsers/gas/gas-token.re"
{
	    if (parser_gas->save_input)
		cursor = save_line(parser_gas, cursor);
	    parser_gas->state = INITIAL;
	    RETURN(s->tok[0]);
	}
#line 3300 "gas-token.c"
yy361:	yych = *++YYCURSOR;
	goto yy362;
yy362:
#line 656 "./modules/parsers/gas/gas-token.re"
{
	    yasm_warn_set(YASM_WARN_UNREC_CHAR,
			  N_("ignoring unrecognized character `%s'"),
			  yasm__conv_unprint(s->tok[0]));
	    goto section_directive;
	}
#line 3311 "gas-token.c"
yy363:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy364;
yy364:	if(yybm[0+yych] & 64) {
		goto yy363;
	}
	goto yy356;
yy365:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy366;
yy366:	if(yybm[0+yych] & 128) {
		goto yy365;
	}
	goto yy352;
}
}
#line 662 "./modules/parsers/gas/gas-token.re"


    /* character constant values */
charconst:
    /*TODO*/

    /* string constant values */
stringconst:
    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
    strbuf_size = STRBUF_ALLOC_SIZE;
    count = 0;

stringconst_scan:
    SCANINIT();

    {

#line 3348 "gas-token.c"
{
	YYCTYPE yych;
	goto yy367;
	++YYCURSOR;
yy367:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych == '"')	goto yy371;
	if(yych != '\\')	goto yy373;
	goto yy369;
yy369:	yych = *++YYCURSOR;
	if(yych == '"')	goto yy374;
	goto yy370;
yy370:
#line 692 "./modules/parsers/gas/gas-token.re"
{
	    strbuf_append(count++, cursor, s, s->tok[0]);
	    goto stringconst_scan;
	}
#line 3368 "gas-token.c"
yy371:	yych = *++YYCURSOR;
	goto yy372;
yy372:
#line 684 "./modules/parsers/gas/gas-token.re"
{
	    strbuf_append(count, cursor, s, '\0');
	    yasm_unescape_cstring(strbuf, &count);
	    lvalp->str.contents = (char *)strbuf;
	    lvalp->str.len = count;
	    RETURN(STRING);
	}
#line 3380 "gas-token.c"
yy373:	yych = *++YYCURSOR;
	goto yy370;
yy374:	yych = *++YYCURSOR;
	goto yy375;
yy375:
#line 679 "./modules/parsers/gas/gas-token.re"
{
	    strbuf_append(count++, cursor, s, '"');
	    goto stringconst_scan;
	}
#line 3391 "gas-token.c"
}
}
#line 696 "./modules/parsers/gas/gas-token.re"


rept_directive:
    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
    strbuf_size = STRBUF_ALLOC_SIZE;
    count = 0;
    linestart = 1;


rept_scan:
    SCANINIT();

    {

#line 3409 "gas-token.c"
{
	YYCTYPE yych;
	unsigned int yyaccept;
	goto yy376;
	++YYCURSOR;
yy376:
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if(yych <= '-'){
		if(yych != '\n')	goto yy382;
		goto yy378;
	} else {
		if(yych <= '.')	goto yy380;
		if(yych != ';')	goto yy382;
		goto yy378;
	}
yy378:	yych = *++YYCURSOR;
	goto yy379;
yy379:
#line 709 "./modules/parsers/gas/gas-token.re"
{
	    /* Line ending, save in lines */
	    new_line = yasm_xmalloc(sizeof(gas_rept_line));
	    if (cursor == s->eof) {
		yasm_xfree(strbuf);
		return 0;
	    }
	    strbuf_append(count++, cursor, s, s->tok[0]);
	    new_line->data = strbuf;
	    new_line->len = count;
	    STAILQ_INSERT_TAIL(&rept->lines, new_line, link);
	    /* Allocate new strbuf */
	    strbuf = yasm_xmalloc(STRBUF_ALLOC_SIZE);
	    strbuf_size = STRBUF_ALLOC_SIZE;
	    count = 0;
	    /* Mark start of line */
	    linestart = 1;
	    goto rept_scan;
	}
#line 3449 "gas-token.c"
yy380:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych == 'E')	goto yy383;
		if(yych >= 'R')	goto yy385;
		goto yy381;
	} else {
		if(yych <= 'e'){
			if(yych >= 'e')	goto yy383;
			goto yy381;
		} else {
			if(yych == 'r')	goto yy385;
			goto yy381;
		}
	}
yy381:
#line 788 "./modules/parsers/gas/gas-token.re"
{
	    if (cursor == s->eof) {
		yasm_xfree(strbuf);
		return 0;
	    }
	    strbuf_append(count++, cursor, s, s->tok[0]);
	    linestart = 0;
	    goto rept_scan;
	}
#line 3476 "gas-token.c"
yy382:	yych = *++YYCURSOR;
	goto yy381;
yy383:	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy390;
	if(yych == 'n')	goto yy390;
	goto yy384;
yy384:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 0:	goto yy381;
	}
yy385:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy386;
	if(yych != 'e')	goto yy384;
	goto yy386;
yy386:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy387;
	if(yych != 'p')	goto yy384;
	goto yy387;
yy387:	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy388;
	if(yych != 't')	goto yy384;
	goto yy388;
yy388:	yych = *++YYCURSOR;
	goto yy389;
yy389:
#line 728 "./modules/parsers/gas/gas-token.re"
{
	    int i;
	    if (linestart) {
		/* We don't support nested right now, error */
		yasm_error_set(YASM_ERROR_GENERAL,
			       N_("nested rept not supported"));
		yasm_errwarn_propagate(parser_gas->errwarns, cur_line);
	    }
	    for (i=0; i<6; i++)
		strbuf_append(count++, cursor, s, s->tok[i]);
	    goto rept_scan;
	}
#line 3515 "gas-token.c"
yy390:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy391;
	if(yych != 'd')	goto yy384;
	goto yy391;
yy391:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy392;
	if(yych != 'r')	goto yy384;
	goto yy392;
yy392:	yych = *++YYCURSOR;
	goto yy393;
yy393:
#line 740 "./modules/parsers/gas/gas-token.re"
{
	    if (linestart) {
		/* We're done, kick off the main lexer */
		rept->line = STAILQ_FIRST(&rept->lines);
		if (!rept->line) {
		    /* Didn't get any intervening data?  Empty repeat, so
		     * don't even bother.
		     */
		    yasm_xfree(strbuf);
		    yasm_xfree(rept);
		    parser_gas->rept = NULL;
		} else {
		    rept->ended = 1;

		    /* Add .line as first line to get line numbers correct */
		    new_line = yasm_xmalloc(sizeof(gas_rept_line));
		    new_line->data = yasm_xmalloc(40);
		    sprintf((char *)new_line->data, ".line %lu;",
			    rept->startline+1);
		    new_line->len = strlen((char *)new_line->data);
		    STAILQ_INSERT_HEAD(&rept->lines, new_line, link);

		    /* Save previous fill buffer */
		    rept->oldbuf = parser_gas->s.bot;
		    rept->oldbuflen = s->lim - s->bot;
		    rept->oldbufpos = cursor - s->bot;

		    /* Reset fill */
		    s->bot = NULL;
		    s->tok = NULL;
		    s->ptr = NULL;
		    s->cur = NULL;
		    s->lim = NULL;
		    s->top = NULL;
		    s->eof = NULL;
		    cursor = NULL;
		    YYFILL(1);
		}

		goto scan;
	    } else {
		int i;
		for (i=0; i<6; i++)
		    strbuf_append(count++, cursor, s, s->tok[i]);
		goto rept_scan;
	    }
	}
#line 3575 "gas-token.c"
}
}
#line 797 "./modules/parsers/gas/gas-token.re"


}
